/*  File FFPEDIT.C  Edit pattern data file  */

#ifndef FFPEDIT_C
#define FFPEDIT_C

#include <conio.h>
#include <alloc.h>

#include "ffpr.h"

void edit_data_file(ff_setup_rec setup,pattern_display_data *disp_data);

/* Implementation  */

void edit_data_file(ff_setup_rec setup,pattern_display_data *disp_data) {
   pattern_array *the_patterns;
   clrscr();
   textcolor (YELLOW);
   gotoxy (1,5);
   cputs ("Edit Pattern Data File");
   gotoxy (1,7);
     if (setup.files.data_file_name[0] == '\0') {
	cprintf ("\r\nData file name is blank.\r\n");
	cputs ("Press key to cancel: ");
	getch();
	return;
	}
     if (setup.files.new_data_file_name[0] == '\0') {
	cprintf ("\r\nOutput Data file name is blank.\r\n");
	cputs ("Press key to cancel: ");
	getch();
	return;
	}
   cprintf ("Name of Pattern File to be Edited: %s",
      setup.files.data_file_name);
   gotoxy (1,9);
   cprintf ("File Name for Storing New Pattern Data: %s",
      setup.files.new_data_file_name);
   gotoxy (1,12);
   cputs ("Press any key to continue (esc to cancel): ");
   if (getch() == ESC_KEY) return;
   clrscr();
   the_patterns = (pattern_array *)malloc((size_t)sizeof(pattern_array));
   if (!read_patterns (disp_data,setup.files.data_file_name,
      *the_patterns)) goto exit_proc;
   cprintf ("\r\nThere are %d patterns, each with %d rows, and %d columns."
	    "\r\n",disp_data->no_of_patterns,disp_data->no_of_rows,
	    disp_data->no_of_cols);
   cputs ("Press any key to continue (esc to cancel): ");
   if (getch() == ESC_KEY) goto exit_proc;
   edit_pattern_file (disp_data,*the_patterns);
   clrscr();
   gotoxy (1,5);
   cputs ("Writing patterns to file...");
   write_patterns (disp_data,setup.files.new_data_file_name,*the_patterns);

   gotoxy (1,8);
   cprintf ("New patterns saved to file %s.",setup.files.new_data_file_name);
   gotoxy (1,10);
   cputs ("Press key to continue: ");
   getch();
exit_proc:
   free (the_patterns);
   textmode (LASTMODE);
   return;
   } /*  procedure  */

#endif