// File SLBSETUP.CPP Set up Turbo Vision interface for
//      Self Organizing Graphic Network

#ifndef SLBSETUP_CPP
#define SLBSETUP_CPP

#include <conio.h>
#include <string.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <io.h>

#include "uisetup.cpp"

extern "C" {
   #include "slfbrm.h"
   }

int set_dynam_system;

class tslbsetapp : public TSetApp
   {
   public :
     tslbsetapp();
     virtual void setup();
     static TMenuBar *initMenuBar (TRect r );
     static void init_submenus();
     virtual void handleEvent (TEvent& event);
     virtual char *save_setup (char *the_file_name);
     virtual char *read_setup (char *the_file_name);
   };

void slb_setup_to_collection (slb_setup_rec *the_slb_setup,
   TDataCollection *the_collection)
   {
      void * value_ptr = NULL;
      tdata_type the_type;
      unsigned short len;
      boolean the_check = TRUE;
      unsigned short dec_places = 0;
      float the_max = 0.0;
      float the_min = 0.0;
      boolean enable = TRUE;
      int item_no = 0;

   value_ptr = &the_slb_setup->the_files.in_wts_file_name;
   the_type = PATH_DATA;
   len = 30;
   dec_places = 0;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Inp Layer Wts File",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"*.WTS",item_no));

   value_ptr = &the_slb_setup->the_files.out_wts_file_name;
   the_type = PATH_DATA;
   len = 30;
   dec_places = 0;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Out Layer Wts File",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"*.WTS",item_no));

   value_ptr = &the_slb_setup->read_wts_from_file;
   the_type = BOOLEAN_DATA;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Read Weights from File?",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->graph_coord_1;
   the_type = INT_DATA;
   len = 2;
   dec_places = 0;
   the_max = NO_OF_INP_WTS;
   the_min = 1;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Graph Coord 1",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->graph_coord_2;
   the_type = INT_DATA;
   len = 2;
   dec_places = 0;
   the_max = NO_OF_INP_WTS;
   the_min = 1;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Graph Coord 2",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->graph_layer;
   the_type = INT_DATA;
   len = 2;
   dec_places = 0;
   the_max = 100;
   the_min = 1;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Graph Layer",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->starting_stepsize;
   the_type = REAL_DATA;
   len = 6;
   dec_places = 4;
   the_max = 1.0;
   the_min = 0.0;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Starting Stepsize",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->x_pos_param;
   the_type = REAL_DATA;
   len = 6;
   dec_places = 4;
   the_check = FALSE;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Reward X Pos Wt",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->theta_dot_param;
   the_type = REAL_DATA;
   len = 6;
   dec_places = 4;
   the_check = FALSE;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Reward Theta Dot Wt",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->force_factor;
   the_type = REAL_DATA;
   len = 5;
   dec_places = 2;
   the_check = TRUE;
   the_max = force_mag;
   the_min = 0.0;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Force Factor",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->freq;
   the_type = INT_DATA;
   len = 3;
   dec_places = 0;
   the_check = TRUE;
   the_max = 100;
   the_min = 1;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Graph Frequency",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->starting_nbhd;
   the_type = INT_DATA;
   len = 5;
   dec_places = 0;
   the_max = 100;
   the_min = 1;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Starting Nbhd Size",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->iter_interval;
   the_type = INT_DATA;
   len = 5;
   dec_places = 0;
   the_max = 10000;
   the_min = 1;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Iteration Interval",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->lattice_rows;
   the_type = INT_DATA;
   the_max = 100;
   the_min = 1;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Lattice Rows",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->lattice_cols;
   the_type = INT_DATA;
   the_max = 100;
   the_min = 1;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Lattice Cols",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->lattice_k;
   the_type = INT_DATA;
   the_max = 100;
   the_min = 1;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Lattice K",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->color;
   the_type = VGA_COLOR_DATA;
   len = 2;
   dec_places = 0;
   the_max = 15;
   the_min = 0;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Net Color",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->gr_rec.scale_window_from_data;
   the_type = BOOLEAN_DATA;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Scale Window from Data?",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->gr_rec.x_min;
   the_type = REAL_DATA;
   the_check = FALSE;
   len = 6;
   dec_places = 4;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Window X Min",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->gr_rec.x_max;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Window X Max",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->gr_rec.y_min;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Window Y Min",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->gr_rec.y_max;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Window Y Max",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   the_type = VGA_COLOR_DATA;
   value_ptr = &the_slb_setup->gr_rec.back_color;
   the_check = TRUE;
   len = 2;
   dec_places = 0;
   the_max = 15;
   the_min = 0;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Background Color",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->gr_rec.line_color;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Line Color",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_slb_setup->gr_rec.text_color;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Text Color",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));
   return;
   }

tslbsetapp::tslbsetapp() : TSetApp(),
   TProgInit (&tslbsetapp::initStatusLine,
	      &tslbsetapp::initMenuBar,
	      &tslbsetapp::initDeskTop
	      )
   {
   slb_setup_to_collection (&slb_rec,system_setup_data.item_collection);
   if (quit_flag == startup) about_dialog();
   }

 void tslbsetapp::init_submenus()
   {
   TSetApp::init_submenus();
   // Skip Data and Special submenus:
   train_submenu->next = NULL;
   // Skip training setup items:
   train_submenu->subMenu->items = train_item;
   train_submenu->subMenu->deflt = train_item;
   return;
   }

TMenuBar *tslbsetapp::initMenuBar ( TRect r )
{
   r.b.y = r.a.y + 1;  //Set bottom line 1 line below top line
   init_submenus();
   return new TMenuBar (r,new TMenu(*about_submenu));
 }

void tslbsetapp::handleEvent (TEvent& event)
 {
    path_str file_name;
    TApplication::handleEvent(event);
    if (event.what == evCommand)
       if (event.message.command == cmSaveWtsAs) {
	     file_name[0] = '\0';
	     get_file_name_dlg ("*.WTS","INPUT LAYER WTS",file_name);
	     if (file_name != "")
	      copy_wts_file ((char *)&ui_files->in_wts_file_name,file_name);
	     else {
	      messageBox ("Invalid WEIGHTS file name.",mfError | mfOKButton);
	      clearEvent(event);
	      return;
	      }
	     file_name[0] = '\0';
	     get_file_name_dlg ("*.WTS","OUTPUT LAYER WTS",file_name);
	     if (file_name != "")
	      copy_wts_file ((char *)&ui_files->out_wts_file_name,file_name);
	     else
	      messageBox ("Invalid WEIGHTS file name.",mfError | mfOKButton);
	     clearEvent(event);
	     return;
	     }
    TSetApp::handleEvent(event);
    clearEvent(event);
    }

void tslbsetapp::setup()
   {
   list_dialog ("SETUP PARAMETERS","",&system_setup_data,
     MAX_NO_OF_SETUP_ITEMS,&standard_processing);
   return;
   }

char *tslbsetapp::save_setup (char *the_file_name)
   {
   write_record (the_file_name,(void *)&slb_rec,sizeof(slb_rec));
   return the_file_name;
   }

char *tslbsetapp::read_setup (char *the_file_name)
   {
   read_record (the_file_name,(void *)&slb_rec,sizeof(slb_rec));
   return the_file_name;
   }

#endif